<template>
  <v-app full-height class="overflow-y-hidden">
    <v-container fluid class="fill-height pa-0">
      <v-row class="fill-height ma-0">
        <v-col
          cols="3"
          color="success"
          class="fill-height madbot-sidebar d-flex flex-column pa-5 overflow-y-auto ma-0"
          style="max-height: 100vh"
        >
          <InvestigationsMenu
            class="mb-auto"
            style="max-height: calc(100vh - 130px); overflow-y: auto"
          />
          <NewInvestigationButton align="center" />
          <Userbar />
        </v-col>
        <v-col class="pa-1 fill-height ma-0">
          <NuxtErrorBoundary>
            <v-main style="max-height: calc(100vh - 10px); overflow-y: auto">
              <slot />
            </v-main>
            <template #error="{ error }">
              <v-main style="max-height: calc(100vh - 10px); overflow-y: auto">
                <slot />
                <v-dialog v-model="dialogError" width="auto" persistent>
                  <v-card>
                    <v-card-title style="color: darkred">
                      <h2>
                        <v-icon size="40px">mdi-close-circle</v-icon>
                        <span>Error {{ error.value.statusCode }}</span>
                        <span v-if="error.value.data.type">
                          : {{ error.value.data.type }}
                        </span>
                      </h2>
                    </v-card-title>
                    <v-card-text>
                      <p v-if="error.value.data.message">{{ error.value.data.message }}</p>
                      <p v-else>{{ error.value.data }}</p>

                      <div v-if="error.value.data.details">
                        <v-expansion-panels class="mt-6">
                          <v-expansion-panel
                            title="Details"
                            icon="mdi-chevron-right"
                            style="color:grey"
                          ><v-expansion-panel-text v-for="(item, index) in error.value.data.details" :key="item">
                            <v-card>
                              <v-card-title>
                                <v-icon size="20px" style="color: darkred" class="mr-1">mdi-close-circle</v-icon>
                                <span>{{ item.field }}</span>
                              </v-card-title>
                              <v-card-text >
                                {{ item.message }}
                              </v-card-text>
                            </v-card>
                          </v-expansion-panel-text>
                          </v-expansion-panel>
                        </v-expansion-panels>
                      </div>
                    </v-card-text>
                    <v-card-actions>
                      <v-btn
                        color="primary"
                        block
                        @click="recoverFromError(error)"
                      >Close</v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-main>
            </template>
          </NuxtErrorBoundary>
        </v-col>
      </v-row>
    </v-container>
  </v-app>
</template>


<script setup>
var dialogError = true;
const recoverFromError = (error) => {
  // Try to resolve the error here
  error.value = null;
};
</script>

<style>
.madbot-sidebar {
  background-color: #fbfbfb;
}
html {
  overflow: hidden; /* Hide scrollbars */
}
</style>
